<?php


defined('MOODLE_INTERNAL') || die();

require_once($CFG->libdir.'/formslib.php');
require_once("$CFG->dirroot/enrol/badiugcurricular/enrollib.php");
require_once("$CFG->dirroot/enrol/badiugcurricular/util.php");



class enrol_badiugcurricular_edit_form extends moodleform {

   function definition() {

        global $DB,$dto,$courseid;
        $manege=new enrol_badiugcurricular_enrollib();
        $ebutil=new enrol_badiugcurricular_util();  
        $course_options=$manege->get_courses($courseid);
        $role_options = get_default_enrol_roles(context_system::instance());
        $mform = $this->_form;
      
        list($instance, $plugin, $context) = $this->_customdata;

        $mform->addElement('header', 'header', get_string('configgeral', 'enrol_badiugcurricular'));

        
        $mform->addElement('hidden', 'id');
        $mform->setType('id', PARAM_INT);
        $mform->setDefault('id', $dto->id);
       
        $mform->addElement('hidden', 'courseid');
        $mform->setType('courseid', PARAM_INT);
         $mform->setDefault('courseid', $dto->courseid);
        
        $mform->addElement('text', 'name', get_string('instancename', 'enrol_badiugcurricular'));
        $mform->setType('name', PARAM_TEXT);
         $mform->setDefault('name', $dto->name);
         $mform->addRule('name', get_string('requiredfield','enrol_badiugcurricular'), 'required', null, 'cliente');
      
        $mform->addElement('select', 'status', get_string('status', 'enrol_badiugcurricular'), $ebutil->enrol_status_options());
       // $mform->addHelpButton('status', 'status', 'enrol_badiugcurricular');
         $mform->setDefault('status', $dto->status);
          $mform->addRule('status', get_string('requiredfield','enrol_badiugcurricular'), 'required', null, 'cliente');
      
         $mform->addElement('select', 'customint1', get_string('allownewenrol', 'enrol_badiugcurricular'), $ebutil->option_yes_not());
        $mform->setType('customint1', PARAM_INT);
          $mform->setDefault('customint1', $dto->customint1);
         $mform->addRule('customint1', get_string('requiredfield','enrol_badiugcurricular'), 'required', null, 'cliente');
      
         
        $mform->addElement('select', 'customint2', get_string('courseconditional', 'enrol_badiugcurricular'), $course_options);
        $mform->setType('customint2', PARAM_INT);
          $mform->setDefault('customint2', $dto->customint2);
        $mform->addRule('customint2', get_string('requiredfield','enrol_badiugcurricular'), 'required', null, 'cliente');
         
        $mform->addElement('select', 'customint5', get_string('gradecondition', 'enrol_badiugcurricular'),$ebutil->option_gradeperc());
        $mform->setType('customint5', PARAM_INT);
         $mform->setDefault('customint5', $dto->customint5);
        $mform->addRule('customint5', get_string('requiredfield','enrol_badiugcurricular'), 'required', null, 'cliente');
       
        $mform->addElement('select', 'roleid', get_string('defaultrole', 'enrol_badiugcurricular'), $role_options);
        $mform->setType('roleid', PARAM_INT);
       $mform->setDefault('roleid', $dto->roleid);
        $mform->addRule('roleid', get_string('requiredfield','enrol_badiugcurricular'), 'required', null, 'cliente');
         
        $mform->addElement('text', 'customint3', get_string('maxuserenrol', 'enrol_badiugcurricular'));
        $mform->setType('customint3', PARAM_INT);
         $mform->setDefault('customint3', $dto->customint3);
        
        $mform->addElement('duration','enrolperiod',  get_string   ('enrolvalidate','enrol_badiugcurricular'), array('optional' => true, 'defaultunit' => 86400));
        $mform->setType('enrolperiod', PARAM_INT);
         $mform->setDefault('enrolperiod', $dto->enrolperiod);
         
        $mform->addElement('htmleditor', 'customtext1', get_string('msgpresentationapproval','enrol_badiugcurricular'),'wrap="virtual" rows="7" cols="40"');
        $mform->setType('customtext1', PARAM_RAW);
         $mform->setDefault('customtext1', $dto->customtext1);
         $mform->addRule('customtext1', get_string('requiredfield','enrol_badiugcurricular'), 'required', null, 'cliente');
       
        $mform->addElement('htmleditor', 'customtext2', get_string('msgpresentationdisapproval','enrol_badiugcurricular'),'wrap="virtual" rows="7" cols="40"');
        $mform->setType('customtext2', PARAM_RAW);
         $mform->setDefault('customtext2', $dto->customtext2);
         $mform->addRule('customtext2', get_string('requiredfield','enrol_badiugcurricular'), 'required', null, 'cliente');
       
       $this->add_action_buttons(true, ($instance->id ? null : get_string('addinstance', 'enrol')));

        $this->set_data($instance);
    }

    function validation($data, $files) {
        global $DB, $CFG;
        $errors = parent::validation($data, $files);

        
        return $errors;
    }

}
