<?php
require_once("$CFG->dirroot/enrol/badiugcurricular/enrollib.php");
require_once("$CFG->dirroot/enrol/badiugcurricular/gradelib.php");

 class enrol_badiugcurricular_process {

     /**
     * @var stdClass
     */
    private $instance;
    /**
     * @var stdClass
     */
    private $lib;
    function __construct(stdClass $instance) {
      $this->instance = $instance;
      $this->lib=new enrol_badiugcurricular_enrollib();
      }
   
      public function exec($userid,$process=FALSE) {
          
          //check if new enrol are allowed
             $result=$this->check_newenrol_allowed();
             if(!empty($result)) return $result;
             
          // check limit enrol user 
            $result=$this->check_user_limit();
             if(!empty($result)) return $result;
          
          // check grade condition e process enrol
           $result= $this->check_grade_condition($userid,$process); 
           return $result;
           
      }    
    
     public function check_newenrol_allowed(){
         if($this->instance->customint1 == 0){
                return get_string('msgnewenrolnotallowed', 'enrol_badiugcurricular');;
           }   
           return null;
    	 
    }
          
     public function check_user_limit(){
           if($this->instance->customint3==0) return null;
           $limituser=$this->lib->count_enrol($this->instance->id);
           if($limituser >= $this->instance->customint3){
                return get_string('msgmaxuserenrol', 'enrol_badiugcurricular');
           }   
           return null;
     }     
   
    public function check_grade_condition($userid,$process){
            
            $condition= $this->has_grade_condition($userid);
            if($process){
                  $enrollib=new enrol_badiugcurricular_enrollib();
                  $enrollib->add_enrol($this->instance->id,$userid,$this->instance->courseid,$this->instance->roleid,$this->instance->enrolperiod);
                return get_string('msgenrolsuccess', 'enrol_badiugcurricular');
            } else{
                 if($condition)  {
                         $result=$this->instance->customtext1;
                         $result.="<br />";
                         $url="/enrol/index.php?id=".$this->instance->courseid."&enrolid=".$this->instance->id;
                         $result.=$this->link_button(get_string('doenrol','enrol_badiugcurricular'),$url);
                         
                        return $result;
                 }
                  else {return $this->instance->customtext2;}
            }
            return null;
           }   
    
    
    public function has_grade_condition($userid){
      
          if($this->instance->customint5==0) return TRUE;
          $grade=new enrol_badiugcurricular_grade($this->instance->customint2);
          $result=$grade->is_approval($userid,$this->instance->customint5);
           return $result;
        
    }
    
        public  function link_button($name_link=null,$relative_url=null){
           global $CFG;
           global $COURSE;
           if(empty($name_link)){$name_link=get_string('doenrol','enrol_badiugcurricular');}
            if(empty($relative_url)){$relative_url="/course/view.php?id=".$COURSE->id;}
           
            $url="'".$CFG->wwwroot.$relative_url."'";
         
         $hml='<form>';
           $hml.=' <input TYPE="button" VALUE="'.$name_link.'"';
           $hml.='  onclick="window.location.href='.$url.'"> ';
           $hml.=' </form>';
         //  $hml=' <a href='.$url.'>'.$name_link.'</a>';
           return $hml;
           
       }
       
      public function getInstance() {
          return $this->instance;
      }

      public function setInstance(stdClass $instance) {
          $this->instance = $instance;
      }


 }